### INSTALL DEPENDENCIES
```
Install system packages:
   $ su
   # yum install epel-release
   # yum install cmake3
   # yum install centos-release-scl
   # yum install devtoolset-11
   # yum install librdkafka-devel
   # yum install boost-devel
   # yum install openssl-devel

Load env vars
    $ echo -e '# Load Devtoolset-11 \nPATH="/opt/rh/devtoolset-11/root/usr/bin"${PATH:+:$PATH}' >> ~/.bashrc
    $ echo 'export BIAS_PREFIX=$HOME/BIAS' >> ~/.bashrc 
    $ source $HOME/.bashrc
```

### CLONE THE REPOSITORY
```
    $ cd $HOME
    $ git clone https://www.ict.inaf.it/gitlab/bias/daqs/astri-daq.git
and Download submodules
    $ cd astri-daq
    $ git submodule update --init --recursive

```

### INSTALL
```
   $ mkdir build
   $ cd build
   $ cmake3 -DCMAKE_INSTALL_PREFIX=$BIAS_PREFIX ..
   $ make all
   $ make install
```

### RUN THE RECEIVER
```
ASTRI_DAQ example:

cd $BIAS_PREFIX/bin
./AstriDAQ.lnx --protocol tcp --ip 127.0.0.1 --port 9003 --provider kafka --packet astri_tm
	// .AstriDAQ.lnx --help for help...
```

### RUN THE SENDER
```
ASTRI_DAQ example:

./Sender.lnx --protocol tcp --ip 127.0.0.1 --port 9003 --source "RAW FILE PATH"

```
