
#ifndef DAQCONFIGURATOR_H_
#define DAQCONFIGURATOR_H_

#include <Base_Configurator.h>
#include <Base_Packet.h>
#include <Base_Protocol.h>
#include <Base_Monitor.h>
#include <Base_Checker.h>
#include <Base_Archiver.h>
#include <Base_Provider.h>

class DAQConfigurator : public BaseConfigurator{

public:
	DAQConfigurator(int argc, char **argv);
	DAQConfigurator();

	void setProtocol(std::string val){this->params["protocol"] = val;}
	void setPacket(std::string val){this->params["packet"] = val;}
	void setArchiverType(std::string val){this->params["archiver"] = val;}
	void setProviderType(std::string val){this->params["provider"] = val;}
	void setCheckerType(std::string val){this->params["checker"] = val;}
	void setMonitor(std::string val){this->params["monitor"] = val;}

	std::map<std::string,std::string> getParams(){return this->params;}
	std::string getProtocol(){return this->params["protocol"];}
	std::string getPacket(){return this->params["packet"];}
	std::string getArchiverType(){return this->params["archiver"];}
	std::string getProviderType(){return this->params["provider"];}
	std::string getCheckerType(){return this->params["checker"];}
	std::string getMonitor(){return this->params["monitor"];}


	void printConfiguration(){
		std::string confStr = "Receiver Configuration:\n" + this->toString();
		std::cout << confStr << std::endl;
	}

	BaseProtocol * createProtocol(int argc, char ** argv);
	BasePacket * createPacket(int argc, char ** argv);
	BaseArchiver * createArchiver(int argc, char ** argv);
	BaseProvider * createProvider(int argc, char ** argv);
	BaseChecker * createChecker(int argc, char ** argv);
	BaseMonitor * createMonitor(int argc, char ** argv);

};

#endif
