
#ifndef SENDERCONFIGURATOR_H_
#define SENDERCONFIGURATOR_H_

#include <Base_Configurator.h>
#include <Base_Packet.h>
#include <Base_Protocol.h>
#include <Base_Monitor.h>


class SenderConfigurator : public BaseConfigurator{

public:
	SenderConfigurator(int argc, char **argv);
	SenderConfigurator();

	void setProtocol(std::string val){this->params["protocol"] = val;}
	void setPacket(std::string val){this->params["packet"] = val;}
	void setMonitor(std::string val){this->params["monitor"] = val;}
	void setMode(std::string val){this->params["mode"] = val;}
	void setSource(std::string val){this->params["source"] = val;}


	std::map<std::string,std::string> getParams(){return this->params;}
	std::string getProtocol(){return this->params["protocol"];}
	std::string getPacket(){return this->params["packet"];}
	std::string getMonitor(){return this->params["monitor"];}
	std::string getMode(){return this->params["mode"];}
	std::string getSource(){return this->params["source"];}


	void printConfiguration(){
		std::string confStr = "Sender Configuration:\n" + this->toString();
		std::cout << confStr << std::endl;
	}

	BaseProtocol * createProtocol(int argc, char ** argv);
	BasePacket * createPacket(int argc, char ** argv);
	BaseMonitor * createMonitor(int argc, char ** argv);

};

#endif /* SENDERCONFIGURATOR_H_ */
