//============================================================================
// Name        : DAQ_PackSender.cpp
// Author      : Valerio Pastore
// Version     :
// Copyright   : Your copyright notice
//============================================================================

#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <chrono>
#include <unordered_map>

#include <Sender_Configurator.h>


using namespace std;

int main(int argc, char **argv){
	SenderConfigurator *configuration = new SenderConfigurator(argc, argv);
	SenderConfigurator &config = *configuration;

	BaseMonitor * monitor = config.createMonitor(argc, argv);
	BaseProtocol * socket = config.createProtocol(argc, argv);
	BasePacket * packet = config.createPacket(argc, argv);


	ifstream file(config.getSource(), ios::in|ios::binary | ios::ate);
	streampos fileSize;

	std::chrono::steady_clock::time_point begin = std::chrono::steady_clock::now();

	if (file.is_open()){
		fileSize = file.tellg();
		cout << "size " << fileSize << endl;
		file.seekg (0, ios::beg);
		socket->connectToServer();
		while(file.tellg() < fileSize){
			file.read((char *)packet->getBufferPtr(),packet->getHeaderSize());
			packet->computeHeaderFieldValues();
//			cout << packet->toString() << endl;
			monitor->monit(*packet);

//			unsigned short int packetLength = (packet->getBufferPtr()[4] << 8 ) | (packet->getBufferPtr()[5] & 0b11111111);

			file.read((char *)&packet->getBufferPtr()[packet->getHeaderSize()],packet->getPayloadSize() + packet->getTailSize());
			int valread = socket->sendPacketToSrv(*packet);

			if(valread < 0){
				std::cout << "Error sending packet" << std::endl;
				break;
			}
			if(file.tellg()%50000 == 0){
				cout << "current position : " << file.tellg() << endl;
				monitor->printStats();
			}
//		usleep(200000);
		}
		file.close();
		std::chrono::steady_clock::time_point end = std::chrono::steady_clock::now();
		std::cout << "Time difference = " << std::chrono::duration_cast<std::chrono::milliseconds>(end - begin).count() << "[ms]" << std::endl;
		monitor->printStats();

	}

	else cout << "Unable to open file\n";

	return 0;
}
